// External Dependencies
var _ = require('underscore');
var Class = require('jc');
var async = require('async');

// Internal Dependencies

// Shortcuts

// Module vars

module.exports = Class({
	
	// Interface ===============================================================
	
	init: function (options) {
		var self = this;
		options = options || {};
		
		self.items = options.items || [];
		self.limit = options.limit || 10;
		self.handler = options.handler || null;
		self.done = options.done || null;
		
		self.proceeded = 0;
	},
	
	start: function () {
		var self = this,
			parts = [];
		for (var i = 0; i < self.items.length; i += self.limit) {
			parts.push(self.items.slice(i, i + self.limit));
		}
		async.forEachSeries(parts, iterator, done);
		
		function iterator(part, callback) {
			async.forEach(part, partIterator, function () {
				callback();
			});
		}
		
		function done() {
			setTimeout(function () {
				self.done();
			}, 0);
		}
		
		function partIterator(item, callback) {
			self.handler(item, callback);
		}
	},
	
	// Realization =============================================================
	
});